local addon, shared = ...

if shared.UIFUNC == nil then
	shared.UIFUNC = {}
end

function shared.UIFUNC.mk_texture(n,c,w,h,l,a)
	local f = UI.CreateFrame("Texture", n,c)
	if w then f:SetWidth(w) end
	if h then f:SetHeight(h) end
	if l then f:SetLayer(l) end
	if a then f:SetAlpha(a) end
	return f
end

function shared.UIFUNC.mk_frame(n,c,w,h,l,a,v)
	local f = UI.CreateFrame("Frame", n,c)
	if w then f:SetWidth(w) end
	if h then f:SetHeight(h) end
	if l then f:SetLayer(l) end
	if a then f:SetAlpha(a) end
	if v ~= nil then f:SetVisible(v) end
	return f
end

function shared.UIFUNC.mk_text(n,c,fs,l,t)
	local f = UI.CreateFrame("Text", n,c)
	if fs then f:SetFontSize(fs) end
	if l then f:SetLayer(l) end
	if t then f:SetText(t) end
	return f
end

local function dd_mousein(self, h)
	self:SetBackgroundColor(0,1,0,1)
end

local function dd_mouseout(self, h)
	self:SetBackgroundColor(0,0,0,1)
end

function shared.UIFUNC.mk_dropdown(n,c,l,w,t,data,chfunc,e)

	local f = shared.UIFUNC.mk_frame(n..".f", c, w, nil,l,nil,nil)
	
	f.ds = shared.UIFUNC.mk_frame(n..".ds", f, w, nil, l+50, nil, false)
	f.ds:SetBackgroundColor(1,0,0,1)

	function f.Update(dx)
		for k,v in pairs(dx) do
			if f.dd[k] == nil then
				f.dd[k] = shared.UIFUNC.mk_text(n..".dd."..k, f.ds, 12, l+51, nil)
				f.dd[k]:SetWidth(w)
				f.dd[k]:SetBackgroundColor(0,0,0,1)
				if k == 1 then
					f.dd[k]:SetPoint("TOPLEFT", f.ds, "TOPLEFT")
				else
					f.dd[k]:SetPoint("TOPLEFT", f.dd[k-1], "BOTTOMLEFT")
				end
				f.dd[k]:EventAttach(Event.UI.Input.Mouse.Cursor.In, dd_mousein, "Event.UI.Input.Mouse.Cursor.In")				
				f.dd[k]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, dd_mouseout, "Event.UI.Input.Mouse.Cursor.Out")
				f.dd[k]:EventAttach(Event.UI.Input.Mouse.Left.Click, function (self, h)
					f.ti:SetText(dx[k].n)
					f.ds:SetVisible(false)
					if chfunc then chfunc(0,0) end
				end, "Event.UI.Input.Mouse.Left.Click")
			end
			f.dd[k]:SetText(v.n)
		end
		
		for x=1, #f.dd do
			if x <= #dx then
				f.dd[x]:SetVisible(true)
			else
				f.dd[x]:SetVisible(false)
			end
		end

		if #dx > 0 then
			f.ds:SetHeight(#dx * f.dd[1]:GetHeight())
		else
			f.ds:SetHeight(0)
		end
	end
	
	f.lb = shared.UIFUNC.mk_text(n..".f.lb", c,14,l+5,t)
	f.lb:SetPoint("TOPLEFT", f, "TOPLEFT")
	f:SetHeight(f.lb:GetHeight())
	
	f.d = shared.UIFUNC.mk_texture(n..".d", c, f.lb:GetHeight(),f.lb:GetHeight(),l+5,nil)
	f.d:SetTexture(addon.identifier, "textures/dropdown.png")
	f.d:SetPoint("TOPRIGHT", f, "TOPRIGHT")
	
	f.d:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h) 
		local dvis = not f.ds:GetVisible()
		f.ds:SetVisible(dvis)
	end, "Event.UI.Input.Mouse.Left.Click")
	
	f.ds:SetPoint("TOPRIGHT", f.d, "BOTTOMRIGHT", 0,2)
	
	if e then
		f.ti = UI.CreateFrame("RiftTextfield", n..".ti", c)
		f.ti:SetLayer(l+3)
	else
		f.ti = shared.UIFUNC.mk_text(n..".ti", c, nil, l+3, nil)
	end
	f.ti:SetBackgroundColor(0,0,0)
	f.ti:SetPoint("TOPLEFT", f.lb, "TOPRIGHT", 2, 0)
	f.ti:SetHeight(f.lb:GetHeight())
	f.ti:SetWidth(w-((f.lb:GetHeight()/2)+f.lb:GetWidth()+2))
	
	function f:GetText(...) return f.ti:GetText(...) end
	function f:SetText(...) f.ti:SetText(...) end
	
	if chfunc and e then
		f.ti:EventAttach(Event.UI.Textfield.Change, chfunc, "Event.UI.Textfield.Change")	
	end
	
	f.dd = {}
	f.Update(data)

	return f
end